<?php

namespace Teknisa\CRM\Geral\Controllers;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Teknisa\CRM\Geral\Services\EnviarEmailService;
use Teknisa\CRM\Geral\Services\EnviarMensagemService;
use Doctrine\ORM\EntityManager;

class EnviarMensagemController extends TeknisaCrud {

    public function __construct (EnviarEmailService $enviarEmailService, EnviarMensagemService $enviarMensagemService, EntityManager $entityManager){
        
        $this->enviarEmailService = $enviarEmailService;
        $this->enviarMensagemService = $enviarMensagemService;
    }
    
    //$codigo -> nrparcnegocio ou cdoperador
    public function enviarEmail($row, $nrorg, $codigo, $from, $toEmail = null, $toName = null, $ccBoss = null, $attach = null, $nrseqinterlocutor = null) {
        
        if($toEmail == null && $toName == null) {
            if (!empty($codigo)) {
                $result = $this->enviarMensagemService->getOperador($nrorg, $codigo); 
                if (!$result) {
                    $result = $this->enviarMensagemService->getInterlocutor($nrorg, $codigo);
                    if(!$result) {
                        return 'AMBOS';
                    }else {
                        if (is_null($result['DSEMAILOPER'])) {
                            return 'DSEMAILOPER';
                        }
                    }
                }
            } else if(!empty($nrseqinterlocutor)) {
                $result = $this->enviarMensagemService->getInterlocutor($nrorg, $nrseqinterlocutor);
            }
        }
        $emailCC = null;
        $nameCC = null;
        if(!is_null($ccBoss)){
            $boss        = $this->enviarMensagemService->getOperadorSuperior($nrorg, $codigo); 
            if(!empty($boss)){
                $emailCC = $boss['DSEMAILOPER'];
                $nameCC = $boss['NMOPERADOR'];
            }
        }
        if(!is_null($from))
            $from        = $this->enviarMensagemService->getOperador($nrorg, $from)['NMOPERADOR']; 
        else
            $from = 'Equipe CRM';
        
        if($toEmail !== null) {
            $dsemailoper = $toEmail;
        } else {
            if(!empty($result['DSEMAILOPER'])) {
                $dsemailoper = $result['DSEMAILOPER'];
            } else if(!empty($result['EMAILINTERLOC'])) {
                $dsemailoper = $result['EMAILINTERLOC'];
            }
        }
        
        
        if($toName !== null) {
            $nmoperador = $toName;
        } else {
            if(!empty($result['NMINTERLOCUTOR'])) {
                $nmoperador  = $result['NMINTERLOCUTOR'];
            }else {
                $nmoperador  = $result['NMOPERADOR'];
            } 
        }    
        
        $replaceMnemonico = array(
            "[DATA]"             => array_key_exists('DATACOMPROMISSO', $row) ? $row['DATACOMPROMISSO'] : '', 
            "[PARTICIPANTE]"     => $nmoperador,
            "[RESPONSAVEL]"      => array_key_exists('RESPONSAVEL', $row) ? $row['RESPONSAVEL'] : '',
            "[PARCEIRO]"         => array_key_exists('PARCEIRO', $row) ? $row['PARCEIRO'] : '',
            "[NOVORESPONSAVEL]"  => array_key_exists('NOVORESPONSAVEL', $row) ? $row['NOVORESPONSAVEL'] : '',
            "[NMOPORT]"          => array_key_exists('NMOPORT', $row) ? $row['NMOPORT'] : '',
            "[NMCLASSOPORT]"     => array_key_exists('NMCLASSOPORT', $row) ? $row['NMCLASSOPORT'] : '',
            "[NMSEQFASENEGO]"    => array_key_exists('NMSEQFASENEGO', $row) ? $row['NMSEQFASENEGO'] : '',
            "[IDTPOPORT]"        => array_key_exists('IDTPOPORT', $row) ? $row['IDTPOPORT'] : '',
            "[IDPARTPEPELINE]"   => array_key_exists('IDPARTPEPELINE', $row) ? $row['IDPARTPEPELINE'] : '',
            "[VRPREVOPORT]"      => array_key_exists('VRPREVOPORT', $row) ? $row['VRPREVOPORT'] : '',
            "[OPERADOR]"         => array_key_exists('OPERADOR', $row) ? $row['OPERADOR'] : '',
            "[TIPO]"             => array_key_exists('TIPO', $row) ? $row['TIPO'] : '',
            "[REFERENCIA]"       => array_key_exists('REFERENCIA', $row) ? $row['REFERENCIA'] : '',
            "[DATACOMPROMISSO]"  => array_key_exists('DATACOMPROMISSO', $row) ? $row['DATACOMPROMISSO'] : '',
            "[DATAEVOLUCAO]"     => array_key_exists('DATAEVOLUCAO', $row) ? $row['DATAEVOLUCAO'] : '',
            "[DATAFINAL]"        => array_key_exists('DATAFINAL', $row) ? $row['DATAFINAL'] : '',
            "[MOTIVO]"           => array_key_exists('MOTIVO', $row) ? $row['MOTIVO'] : '',
            "[INTERLOCUTOR]"     => array_key_exists('INTERLOCUTOR', $row) ? $row['INTERLOCUTOR'] : '',
            "[NRSEQCONTATO]"     => array_key_exists('NRSEQCONTATO', $row) ? $row['NRSEQCONTATO'] : '',
            "[PRODUTO]"          => array_key_exists('PRODUTO', $row) ? $row['PRODUTO'] : '',
            "[DATACONCLUSAO]"    => array_key_exists('DATACONCLUSAO', $row) ? $row['DATACONCLUSAO'] : '',
            "[DATAINCLUSAO]"     => array_key_exists('DATAINCLUSAO', $row) ? $row['DATAINCLUSAO'] : '',
            "[CLIENTE]"          => array_key_exists('CLIENTE', $row) ? $row['CLIENTE'] : '',
            "[DESCRICAO]"        => array_key_exists('DESCRICAO', $row) ? $row['DESCRICAO'] : '',
            "[LINK]"             => array_key_exists('LINK', $row) ? $row['LINK'] : '',
            "[LABELLINK]"        => array_key_exists('LABELLINK', $row) ? $row['LABELLINK'] : '',
        );
        
        $row['DSMENSAGEM'] = strtr($row['DSMENSAGEM'], $replaceMnemonico);
        $subject = strtr($row['DSTITULOMENSAGEM'], $replaceMnemonico);
        
        if($codigo){
            $logo = $this->enviarMensagemService->getLogoCliente($nrorg, $codigo); 
            if($logo == 'S')
                $logo = '';
        } else if(!empty($nrseqinterlocutor)) {
            $logo = $this->enviarMensagemService->getLogoCliente($nrorg, $nrseqinterlocutor); 
            if($logo == 'S')
                $logo = '';
        }
        
        $content = array(
            "SUBJECT"                 => $subject,
            "STRING_SUPERIOR_DIREITA" => "",
            "CONTENT_BODY"            => $row['DSMENSAGEM'],
            "URL_LOGO_CLIENTE"        => isset($logo) ? $logo : ''    
        );

        if (!isset($row['DSEMAILOPERLOG']))
            $row['DSEMAILOPERLOG'] = $dsemailoper;

        $toName = $nmoperador;
        $this->enviarEmailService->enviarEmailCompromisso('TEKNISA',  $dsemailoper, $subject, $content, $from, $toName, $emailCC, $nameCC, $attach);

        return true;
    }
}