/* Tabela NOTADESTINADA: Notas contra o CNPJ */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela NOTADESTINADA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela NOTADESTINADA,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_NOTADESTINADA
AFTER DELETE OR INSERT OR UPDATE
ON NOTADESTINADA FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(4000);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DTOPER       DATE;
  V_TAM          INTEGER;

BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
--      IF :OLD.NRNFDESTINADA IS NOT NULL THEN
--         V_DESC := V_DESC || 'NrNFDest=' || :OLD.NRNFDESTINADA;
--      END IF;

      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' IE=' || :OLD.CDINSCESTA;
      END IF;

      IF :OLD.SGESTADO IS NOT NULL THEN
         V_DESC := V_DESC || ' UF=' || :OLD.SGESTADO;
      END IF;

      IF :OLD.NRNSU IS NOT NULL THEN
         V_DESC := V_DESC || ' NSU=' || :OLD.NRNSU;
      END IF;

      IF :OLD.NRACESSONFE IS NOT NULL THEN
         V_DESC := V_DESC || ' ChaveNFe=' || :OLD.NRACESSONFE;
      END IF;

      IF :OLD.NRINSJUREMIT IS NOT NULL THEN
         V_DESC := V_DESC || ' Ins.Emitente=' || :OLD.NRINSJUREMIT;
      END IF;

      IF :OLD.NMRAZSOCEMIT IS NOT NULL THEN
         V_DESC := V_DESC || ' RazSocEmitente=' || :OLD.NMRAZSOCEMIT;
      END IF;

      IF :OLD.CDINSCESTAEMIT IS NOT NULL THEN
         V_DESC := V_DESC || ' IEEmitente=' || :OLD.CDINSCESTAEMIT;
      END IF;

      IF :OLD.DTEMISSAO IS NOT NULL THEN
         V_DESC := V_DESC || ' DtEmiss=' || :OLD.DTEMISSAO;
      END IF;

      IF :OLD.NRNOTAFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' NrEmiss=' || :OLD.NRNOTAFISC;
      END IF;

      IF :OLD.IDENTRSAIDNF IS NOT NULL THEN
         V_DESC := V_DESC || ' E/S=' || :OLD.IDENTRSAIDNF;
      END IF;

      IF :OLD.VRNOTAFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' VrNota=' || :OLD.VRNOTAFISC;
      END IF;

      IF :OLD.CDDIGESTVALUE IS NOT NULL THEN
         V_DESC := V_DESC || ' DigestValue=' || :OLD.CDDIGESTVALUE;
      END IF;

      IF :OLD.DTRECBTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Dt.Aut=' || :OLD.DTRECBTO;
      END IF;

      IF :OLD.IDSTATUSNFE IS NOT NULL THEN
         V_DESC := V_DESC || ' StatusNFe=' || :OLD.IDSTATUSNFE;
      END IF;

      IF :OLD.IDSTATUSMANIF IS NOT NULL THEN
         V_DESC := V_DESC || ' StatusManif=' || :OLD.IDSTATUSMANIF;
      END IF;

      IF :OLD.IDTIPOEVENTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Evento=' || :OLD.IDTIPOEVENTO;
      END IF;

      IF :OLD.DTHREVENTO IS NOT NULL THEN
         V_DESC := V_DESC || ' DtEvento=' || :OLD.DTHREVENTO;
      END IF;

      IF :OLD.NRSEQEVENTO IS NOT NULL THEN
         V_DESC := V_DESC || ' SeqEvento=' || :OLD.NRSEQEVENTO;
      END IF;

      IF :OLD.DSCORRECAONFE  IS NOT NULL THEN
         V_DESC := V_DESC || ' DsCorrecao=' || :OLD.DSCORRECAONFE ;
      END IF;

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFilial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.NRLANCTONF IS NOT NULL THEN
         V_DESC := V_DESC || ' NrLanc=' || :OLD.NRLANCTONF;
      END IF;

      IF :OLD.NRACESSOINTG IS NOT NULL THEN
         V_DESC := V_DESC || ' Intg=' || :OLD.NRACESSOINTG;
      END IF;

      IF :OLD.IDAMBIENTEMANIF IS NOT NULL THEN
         V_DESC := V_DESC || ' Amb=' || :OLD.IDAMBIENTEMANIF;
      END IF;

      IF :OLD.DSOBSSTATUSMANIF IS NOT NULL THEN
         V_DESC := V_DESC || ' ObsManif=' || :OLD.DSOBSSTATUSMANIF;
      END IF;

      IF :OLD.NRLOTEMANIF IS NOT NULL THEN
         V_DESC := V_DESC || ' LoteEven=' || :OLD.NRLOTEMANIF;
      END IF;

      IF :OLD.NRPROTOCOLO IS NOT NULL THEN
         V_DESC := V_DESC || ' Protocolo=' || :OLD.NRPROTOCOLO;
      END IF;

      IF :OLD.CDIBGEESTADOA IS NOT NULL THEN
         V_DESC := V_DESC || ' UFAut=' || :OLD.CDIBGEESTADOA;
      END IF;

      IF :OLD.IDASSINATURA IS NOT NULL THEN
         V_DESC := V_DESC || ' Ass=' || :OLD.IDASSINATURA;
      END IF;

--      IF :OLD.NRDOWNLOADXML IS NOT NULL THEN
--         V_DESC := V_DESC || ' NrDown=' || :OLD.NRDOWNLOADXML;
--      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRNFDESTINADA;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (:OLD.NRNFDESTINADA    <> :NEW.NRNFDESTINADA)   OR
            (:OLD.CDINSCESTA       <> :NEW.CDINSCESTA)      OR
            (:OLD.SGESTADO         <> :NEW.SGESTADO)     OR
            (:OLD.NRNSU            <> :NEW.NRNSU)  OR
            (:OLD.NRACESSONFE      <> :NEW.NRACESSONFE)   OR
            (:OLD.NRINSJUREMIT     <> :NEW.NRINSJUREMIT)    OR
            (:OLD.NMRAZSOCEMIT     <> :NEW.NMRAZSOCEMIT)   OR
            (:OLD.CDINSCESTAEMIT   <> :NEW.CDINSCESTAEMIT)   OR
            (:OLD.DTEMISSAO        <> :NEW.DTEMISSAO)   OR
            (:OLD.NRNOTAFISC       <> :NEW.NRNOTAFISC) OR
            (:OLD.IDENTRSAIDNF     <> :NEW.IDENTRSAIDNF)   OR
            (:OLD.VRNOTAFISC       <> :NEW.VRNOTAFISC)      OR
            (:OLD.CDDIGESTVALUE    <> :NEW.CDDIGESTVALUE)  OR
            (:OLD.DTRECBTO         <> :NEW.DTRECBTO)     OR
            (:OLD.IDSTATUSNFE      <> :NEW.IDSTATUSNFE)  OR
            (:OLD.IDSTATUSMANIF    <> :NEW.IDSTATUSMANIF)    OR
            (:OLD.IDTIPOEVENTO     <> :NEW.IDTIPOEVENTO) OR
            (:OLD.DTHREVENTO       <> :NEW.DTHREVENTO)  OR
            (:OLD.NRSEQEVENTO      <> :NEW.NRSEQEVENTO) OR
            (:OLD.DSCORRECAONFE    <> :NEW.DSCORRECAONFE) OR
            (:OLD.CDFILIAL         <> :NEW.CDFILIAL )  OR
            (:OLD.NRLANCTONF       <> :NEW.NRLANCTONF)   OR
            (:OLD.NRACESSOINTG     <> :NEW.NRACESSOINTG)   OR
            (:OLD.IDAMBIENTEMANIF  <> :NEW.IDAMBIENTEMANIF) OR
            (:OLD.DSOBSSTATUSMANIF <> :NEW.DSOBSSTATUSMANIF) OR
            (:OLD.NRLOTEMANIF      <> :NEW.NRLOTEMANIF)   OR
            (:OLD.NRPROTOCOLO      <> :NEW.NRPROTOCOLO)  OR
            (:OLD.CDIBGEESTADOA    <> :NEW.CDIBGEESTADOA)  OR
            (:OLD.IDASSINATURA     <> :NEW.IDASSINATURA)    OR
            (:OLD.NRDOWNLOADXML    <> :NEW.NRDOWNLOADXML) THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRNFDESTINADA;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRNFDESTINADA;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

--      IF NVL(:NEW.NRNFDESTINADA, '!') <> NVL(:OLD.NRNFDESTINADA, '!') THEN
--         V_DESC := V_DESC || 'NrNFDest=' || :NEW.NRNFDESTINADA;
--      END IF;

      IF NVL(:NEW.CDINSCESTA, '!') <> NVL(:OLD.CDINSCESTA, '!') THEN
         V_DESC := V_DESC || ' IE=' || :NEW.CDINSCESTA;
      END IF;

      IF NVL(:NEW.SGESTADO, '!') <> NVL(:OLD.SGESTADO, '!') THEN
         V_DESC := V_DESC || ' UF=' || :NEW.SGESTADO;
      END IF;

      IF NVL(:NEW.NRNSU, '!') <> NVL(:OLD.NRNSU, '!') THEN
         V_DESC := V_DESC || ' NSU=' || :NEW.NRNSU;
      END IF;

      IF NVL(:NEW.NRACESSONFE, '!') <> NVL(:OLD.NRACESSONFE, '!') THEN
         V_DESC := V_DESC || ' ChaveNFe=' || :NEW.NRACESSONFE;
      END IF;

      IF NVL(:NEW.NRINSJUREMIT, '!') <> NVL(:OLD.NRINSJUREMIT, '!') THEN
         V_DESC := V_DESC || ' Ins.Emitente=' || :NEW.NRINSJUREMIT;
      END IF;

      IF NVL(:NEW.NMRAZSOCEMIT, '!') <> NVL(:OLD.NMRAZSOCEMIT, '!') THEN
         V_DESC := V_DESC || ' RazSocEmitente=' || :NEW.NMRAZSOCEMIT;
      END IF;

      IF NVL(:NEW.CDINSCESTAEMIT, '!') <> NVL(:OLD.CDINSCESTAEMIT, '!') THEN
         V_DESC := V_DESC || ' IEEmitente=' || :NEW.CDINSCESTAEMIT;
      END IF;

      IF (:NEW.DTEMISSAO IS NOT NULL) AND (:NEW.DTEMISSAO <> :OLD.DTEMISSAO) THEN
         V_DESC := V_DESC || ' DtEmiss=' || :NEW.DTEMISSAO;
      END IF;

      IF NVL(:NEW.NRNOTAFISC, '!') <> NVL(:OLD.NRNOTAFISC, '!') THEN
         V_DESC := V_DESC || ' NrEmiss=' || :NEW.NRNOTAFISC;
      END IF;

      IF NVL(:NEW.IDENTRSAIDNF, '!') <> NVL(:OLD.IDENTRSAIDNF, '!') THEN
         V_DESC := V_DESC || ' E/S=' || :NEW.IDENTRSAIDNF;
      END IF;

      IF (:NEW.VRNOTAFISC IS NOT NULL) AND (:NEW.VRNOTAFISC <> :OLD.VRNOTAFISC) THEN
         V_DESC := V_DESC || ' VrNota=' || :NEW.VRNOTAFISC;
      END IF;

      IF NVL(:NEW.CDDIGESTVALUE, 1) <> NVL(:OLD.CDDIGESTVALUE, 1) THEN
         V_DESC := V_DESC || ' DigestValue=' || :NEW.CDDIGESTVALUE;
      END IF;

      IF (:NEW.DTRECBTO IS NOT NULL) AND (:NEW.DTRECBTO <> :OLD.DTRECBTO) THEN
         V_DESC := V_DESC || ' Dt.Aut=' || :NEW.DTRECBTO;
      END IF;

      IF NVL(:NEW.IDSTATUSNFE, '!') <> NVL(:OLD.IDSTATUSNFE, '!') THEN
         V_DESC := V_DESC || ' StatusNFe=' || :NEW.IDSTATUSNFE;
      END IF;

      IF NVL(:NEW.IDSTATUSMANIF, '!') <> NVL(:OLD.IDSTATUSMANIF, '!') THEN
         V_DESC := V_DESC || ' StatusManif=' || :NEW.IDSTATUSMANIF;
      END IF;

      IF NVL(:NEW.IDTIPOEVENTO, '!') <> NVL(:OLD.IDTIPOEVENTO, '!') THEN
         V_DESC := V_DESC || ' Evento=' || :NEW.IDTIPOEVENTO;
      END IF;

      IF (:NEW.DTHREVENTO IS NOT NULL) AND (:NEW.DTHREVENTO <> :OLD.DTHREVENTO) THEN
         V_DESC := V_DESC || ' DtEvento=' || :NEW.DTHREVENTO;
      END IF;

      IF NVL(:NEW.NRSEQEVENTO, '!') <> NVL(:OLD.NRSEQEVENTO, '!') THEN
         V_DESC := V_DESC || ' SeqEvento=' || :NEW.NRSEQEVENTO;
      END IF;

      IF NVL(:NEW.DSCORRECAONFE, '!') <> NVL(:OLD.DSCORRECAONFE, '!') THEN
         V_DESC := V_DESC || ' DsCorrecao=' || :NEW.DSCORRECAONFE;
      END IF;

      IF NVL(:NEW.CDFILIAL, '!') <> NVL(:OLD.CDFILIAL, '!') THEN
         V_DESC := V_DESC || ' CdFilial=' || :NEW.CDFILIAL;
      END IF;

      IF NVL(:NEW.NRLANCTONF, '!') <> NVL(:OLD.NRLANCTONF, '!') THEN
         V_DESC := V_DESC || ' NrLanc=' || :NEW.NRLANCTONF;
      END IF;

      IF NVL(:NEW.NRACESSOINTG, '!') <> NVL(:OLD.NRACESSOINTG, '!') THEN
         V_DESC := V_DESC || ' Intg=' || :NEW.NRACESSOINTG;
      END IF;

      IF NVL(:NEW.IDAMBIENTEMANIF, '!') <> NVL(:OLD.IDAMBIENTEMANIF, '!') THEN
         V_DESC := V_DESC || ' Amb=' || :NEW.IDAMBIENTEMANIF;
      END IF;

      IF NVL(:NEW.DSOBSSTATUSMANIF, '!') <> NVL(:OLD.DSOBSSTATUSMANIF, '!') THEN
         V_DESC := V_DESC || ' ObsManif=' || :NEW.DSOBSSTATUSMANIF;
      END IF;

      IF NVL(:NEW.NRLOTEMANIF, '!') <> NVL(:OLD.NRLOTEMANIF, '!') THEN
         V_DESC := V_DESC || ' LoteEven=' || :NEW.NRLOTEMANIF;
      END IF;

      IF NVL(:NEW.NRPROTOCOLO, '!') <> NVL(:OLD.NRPROTOCOLO, '!') THEN
         V_DESC := V_DESC || ' Protocolo=' || :NEW.NRPROTOCOLO;
      END IF;

      IF NVL(:NEW.CDIBGEESTADOA, '!') <> NVL(:OLD.CDIBGEESTADOA, '!') THEN
         V_DESC := V_DESC || ' UFAut=' || :NEW.CDIBGEESTADOA;
      END IF;

      IF NVL(:NEW.IDASSINATURA, '!') <> NVL(:OLD.IDASSINATURA, '!') THEN
         V_DESC := V_DESC || ' Ass=' || :NEW.IDASSINATURA;
      END IF;

--      IF NVL(:NEW.NRDOWNLOADXML, '!') <> NVL(:OLD.NRDOWNLOADXML, '!') THEN
--         V_DESC := V_DESC || ' NrDown=' || :NEW.NRDOWNLOADXML;
--      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            V_TAM := LENGTH(V_DESC);
            WHILE (V_TAM >= 0) LOOP
               INSERT INTO LOGOPERA
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   CDFILLOGOPER,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('NOTADESTINADA',
                   V_DTOPER,
                   V_USUARIO,
                   V_TIPO,
                   V_ITPESQ,
                   SUBSTR(V_DESC,1,600),
                   V_CDFILLOGOPER,
                   V_DSSERVERRDM,
                   V_DSREMOTEADDR,
                   V_DSREMOTEHOST,
                   V_DSSERVMETHOD,
                   V_DSREMOTEOPER);

                V_DESC := SUBSTR(V_DESC, 600, V_TAM);   
                V_TAM := LENGTH(V_DESC);
             END LOOP;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_NOTADESTINADA','6.05.xxx'); END;
/

