var CRM_ParceiroNegocio_Controller = function(ScreenService, Utilities, General, CRM_ParceiroNegocio_Service, Endereco, templateManager, CRM_Utilities, AbaInterlocutorController, restEngine, ChamadoController, ABALogotipoParceiroController, localStorageEngine) {

    CRM_Utilities.addController(this, 'CRM_ParceiroNegocio_Controller');
    
    this.alteraEstadoReadonly = function(widget) {
        var paisField = widget.getField("NMPAIS");
        var estadoField = widget.getField("NMESTADO");
        var currentRow = widget.currentRow;
        if (!paisField.value()) {
            estadoField.readOnly = true;
            currentRow.SGESTADO = null;
            currentRow.NMESTADO = null;
        }
        else {
            estadoField.readOnly = false;
        }
        this.alteraMunicipioReadonly(widget);
    };

    this.alteraMunicipioReadonly = function(widget) {
        var estadoField = widget.getField("NMESTADO");
        var municipioField = widget.getField("NMMUNICIPIO");
        var currentRow = widget.currentRow;
        if (!estadoField.value()) {
            municipioField.readOnly = true;
            currentRow.NMMUNICIPIO = null;
            currentRow.CDMUNICIPIO = null;
            currentRow.NMMUNICIPIO = null;
        }
        else {
            municipioField.readOnly = false;
        }
        this.alteraBairroReadonly(widget);
    };

    this.alteraBairroReadonly = function(widget) {
        var municipioField = widget.name == "parceiroNegocio" ? widget.getField("NMMUNICIPIO") : widget.getField("NMMUNICIPIO");
        var bairroField = widget.name == "parceiroNegocio" ? widget.getField("NMBAIRROTRAN") : widget.getField("NMBAIRRO");
        var currentRow = widget.currentRow;
        if (!municipioField.value()) {
            bairroField.readOnly = true;
            currentRow.NMBAIRRO = null;
            currentRow.CDBAIRRO = null;
            currentRow.NMBAIRRO = null;
        }
        else {
            bairroField.readOnly = false;
        }
    };


    this.cancelarNovoParceiro = function() {
        var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
        enderecoPrincipalWidget.isVisible = false;
        enderecoPrincipalWidget.showAsTab = false;

        var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
        enderecoWidget.isVisible = true;
        enderecoWidget.showAsTab = true;

        var parentWidget = templateManager.container.getWidget("parceiroNegocio");
        parentWidget.list();
        parentWidget.dataSource.data.pop();
        parentWidget.currentRow = {};
        toggleWidgetsEnabled(parentWidget.widgets, true);
        ScreenService.goBack();
    };

    this.checkDataExists = function(field, sourceName, sourceParent) {
        field.reload().then(function() {
            if (!(field.dataSource.data && field.dataSource.data.length > 0)) {
                ScreenService.showMessage(ScreenService.i18n("Não há " + sourceName + " cadastrado para o " + sourceParent + " informado."));
            }
        });
    };

    this.cancelEditParceiro = function(args) {
        var parentWidget = args.owner.widget;
        if (parentWidget.isNewRow()) {
            this.cancelarNovoParceiro();
        } else {
            General.backOrCancel(args);
            toggleWidgetsEnabled(parentWidget.widgets, true);
        }
    }; 

    this.checkTransportadoraIsSelected = function(widget, editingWidget) {
        var tiposParceiro = widget.currentRow.TIPODEPARCEIRO;
        if (Array.isArray(tiposParceiro) && tiposParceiro.indexOf("TRANSPORTADORA") !== -1) {
            if (tiposParceiro.indexOf("FORNECEDOR") === -1 && editingWidget) {
                widget.currentRow.TIPODEPARCEIRO.push("FORNECEDOR");
            }
            changeTransportFieldsVisibility(widget, true);
        }
        else {
            changeTransportFieldsVisibility(widget, false);
        }
    };

    var changeTransportFieldsVisibility = function(widget, isVisible) {
        var fieldGroups = widget.fieldGroups.filter(function(fieldGroup) {
            return fieldGroup.name == "transportadora";
        });
        if (fieldGroups[0]) {
            fieldGroups[0].isVisible = isVisible;
        }
        if (!isVisible) {
            var currentRow = widget.currentRow;
            widget.getField("NRINSESTTRANFORMAT").validations = {};
            widget.getField("NRCEPENDERECO").validations = {};
            widget.getField("NMPAIS").validations = {};
            widget.getField("NMESTADO").validations = {};
            if(!Util.isEmptyOrBlank(widget.getField("NMMUNICIP"))) {
                widget.getField("NMMUNICIP").validations = {};
            } else if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIPIO"))) {
                widget.getField("NMMUNICIPIO").validations = {};
            }
            widget.getField("NMBAIRRO").validations = {};
            widget.getField("DSENDERECO").validations = {};
            currentRow.NRINSESTTRAN = null;
            currentRow.NRCEPENDERECO = null;
            currentRow.NMPAIS = null;
            currentRow.NMESTADO = null;
            if(!Util.isEmptyOrBlank(widget.getField("NMMUNICIP"))) {
                currentRow.NMMUNICIP = null;
            } else if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIPIO"))) {
                currentRow.NMMUNICIPIO = null;
            }
            currentRow.NMBAIRRO = null;
            currentRow.DSENDERECO = null;
        }
        else {
            widget.getField("NRINSESTTRANFORMAT").validations = {required: true};
            widget.getField("NRCEPENDERECO").validations = {required: true};
            widget.getField("NMPAIS").validations = {required: true};
            widget.getField("NMESTADO").validations = {required: true};
            if(!Util.isEmptyOrBlank(widget.getField("NMMUNICIP"))) {
                widget.getField("NMMUNICIP").validations = {required: true};
            } else if (!Util.isEmptyOrBlank(widget.getField("NMMUNICIPIO"))) {
                widget.getField("NMMUNICIPIO").validations = {required: true};
            }
            widget.getField("NMBAIRRO").validations = {required: true};
            widget.getField("DSENDERECO").validations = {required: true};
        }
    };

    this.editEnderecoParceiro = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.edit(widget);
                    this.alteraEstadoReadonly(widget);
                    widget.getField("CDTIPOENDERECO").readOnly = (widget.currentRow.CDTIPOENDERECO == "PRINCIPAL");
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.edit(widget);
            this.alteraEstadoReadonly(widget);
            widget.getField("CDTIPOENDERECO").readOnly = (widget.currentRow.CDTIPOENDERECO == "PRINCIPAL");
        }
        
    };

    this.editParceiro = function(parentWidget) {
        var nrParcNegocio = parentWidget.currentRow.NRPARCNEGOCIO;
        var tipoParc = parentWidget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.edit(parentWidget);
                    toggleWidgetsEnabled(parentWidget.widgets, false);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.edit(parentWidget);
            toggleWidgetsEnabled(parentWidget.widgets, false);
        }
        
    }; 

    this.enderecoAfterMoveRow = function(widget) {
        widget.actions.filter(function(action) {
            return action.name == "delete";
        })[0].isVisible = (widget.currentRow.CDTIPOENDERECO != "PRINCIPAL");
    };

    this.novoComunicacao = function(widget) {
        var parentRow = widget.parent.parent.currentRow;
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    widget.edit();
                    widget.newRow();
                    widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
                    //widget.currentRow.NRENDERECOPARC = '5';
                    widget.currentRow.CDCOMPLECOMUPARC  = '5';
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            widget.edit();
            widget.newRow();
            widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
            //widget.currentRow.NRENDERECOPARC = '5';
            widget.currentRow.CDCOMPLECOMUPARC  = '5';
        }
        
        
    };

    this.novoEndeParc = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    var parentRow = widget.parent.parent.currentRow;
                    widget.edit();
                    widget.newRow();
                    widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
                    widget.getField("CDTIPOENDERECO").readOnly = false;
                    this.alteraEstadoReadonly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            var parentRow = widget.parent.parent.currentRow;
            widget.edit();
            widget.newRow();
            widget.currentRow.NRPARCNEGOCIO = parentRow.NRPARCNEGOCIO;
            widget.getField("CDTIPOENDERECO").readOnly = false;
            this.alteraEstadoReadonly(widget);
        }
        
    };

    this.novoParceiro = function(widget) {
        widget.newRow();
        toggleWidgetsEnabled(widget.widgets, false);

        var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
        enderecoWidget.isVisible = false;
        enderecoWidget.showAsTab = false;

        var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
        enderecoPrincipalWidget.newRow();
        enderecoPrincipalWidget.enabled = true;
        enderecoPrincipalWidget.isVisible = true;
        enderecoPrincipalWidget.showAsTab = true;
        enderecoPrincipalWidget.currentRow.NMTIPOENDERECO = "Principal";
        enderecoPrincipalWidget.currentRow.CDTIPOENDERECO = "PRINCIPAL";

        this.alteraEstadoReadonly(enderecoWidget);
        this.alteraEstadoReadonly(enderecoPrincipalWidget);

        widget.currentRow.IDPESSOAFISICA = 'N';
        widget.currentRow.IDPARCFUNDIDO = 'N';
        widget.currentRow.IDINSTITUICAO = 'N';
    };

    this.nrinscricaoOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        if (field.value()) {
            var validations = General.inscricaoFormat(field.value(), true);
            var tipoInscricaoParceiro = CRM_ParceiroNegocio_Service.getTipoInscricao(validations.tipo.cod);
            if (tipoInscricaoParceiro === undefined) {
                ScreenService.showMessage(ScreenService.i18n("Ocorreu um erro ao validar a inscrição."));
            }
            else {
                currentRow.NRINSCRICAOPARCFORMAT = validations.value;
                currentRow.CDTIPOINSCRICAO = tipoInscricaoParceiro;
                currentRow.NRINSCRICAOPARC = validations.parameter;
                if (tipoInscricaoParceiro == "CPF") {
                    currentRow.IDPESSOAFISICA = 'S';
                    currentRow.IDINSTITUICAO = 'N';
                }
                else {
                    currentRow.IDPESSOAFISICA = 'N';
                    currentRow.IDINSTITUICAO = 'S';
                    if (tipoInscricaoParceiro != "CNPJ") {
                        currentRow.NRINSCRICAOPARC = validations.value;
                    }
                }
            }
        }
        else {
            currentRow.CDTIPOINSCRICAO = null;
            currentRow.NRINSCRICAOPARC = null;
        }
    };

    this.nrinscricaoEstadualOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        if (field.value()) {
            var validations = General.inscricaoFormat(field.value(), true);
            var tipoInscricaoParceiro = CRM_ParceiroNegocio_Service.getTipoInscricao(validations.tipo.cod);
            if (tipoInscricaoParceiro === undefined) {
                ScreenService.showMessage(ScreenService.i18n("Ocorreu um erro ao validar a inscrição estadual."));
            }
            else {
                currentRow.NRINSESTTRANFORMAT = validations.value;
                currentRow.NRINSESTTRAN = tipoInscricaoParceiro == "LIVRE" ? validations.value : validations.parameter;
            }
        }
        else {
            currentRow.NRINSESTTRAN = null;
        }
    };

    this.parceiroAfterMoveRow = function(widget) {
        ChamadoController.setTagsOnCurrentRow(widget, 'PARCNEGOCIO');
        
        
        var tiposDeParceiro = widget.currentRow.TIPODEPARCEIRO;
        if(tiposDeParceiro && !Array.isArray(tiposDeParceiro)) {
            widget.currentRow.TIPODEPARCEIRO = tiposDeParceiro.split(",");
            widget.currentRow.TIPODEPARCEIRO = tiposDeParceiro.split(", ");
        }
        if(!widget.isNewRow()) {
            var nrInscricao = widget.currentRow.NRINSCRICAOPARC;
            var nrInscricaoTrans = widget.currentRow.NRINSESTTRAN;
            var validations = General.inscricaoFormat(nrInscricao, true);
            widget.currentRow.NRINSCRICAOPARCFORMAT = validations.value;
            if (nrInscricaoTrans) {
                validations = General.inscricaoFormat(nrInscricaoTrans, true);
                widget.currentRow.NRINSESTTRANFORMAT = validations.value;
            }
        }
        
        this.checkTransportadoraIsSelected(widget);
        this.setInscEstadualSelect(widget);
        
        var help;
        var tipoParceiro = widget.getField('TIPODEPARCEIRO');
        if(widget.currentRow.CDTIPOPARCPRINCIPAL == 'CLIENTE') {
            tipoParceiro.help = "Caso este campo não possua 'Lead', 'Prospect' e 'Cliente', utilize o botão 'atualizar parceria'.";
        }else if(widget.currentRow.CDTIPOPARCPRINCIPAL == 'PROSPECT') {
            tipoParceiro.help = "Caso este campo não possua 'Lead' e 'Prospect', utilize o botão 'atualizar parceria'.";
        }else if(widget.currentRow.CDTIPOPARCPRINCIPAL == 'CANDIDATO') {
            tipoParceiro.help = "";
        }
    };

    this.salvarComunicacao = function(args) {
        var currentRow = args.row;
        var widget = args.owner.widget;
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    var paramsNewCode = widget.paramsNewCode;
            
                    var keysParamsNewCode = Object.keys(paramsNewCode);
                    keysParamsNewCode.forEach(function(value) {
                        currentRow[value] = paramsNewCode[value];
                    });
            
                    if (widget.isValid()) {
                        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                        CRM_ParceiroNegocio_Service.salvarComunicacao(currentRow).then(function(successData) {
                            if (widget.isNewRow()) {
                                widget.currentRow.NRCOMUNICAPARC = successData.dataset.columnsToReturn.NRCOMUNICAPARC;
                                widget.currentRow.NRORG = successData.dataset.columnsToReturn.NRORG;
                                widget.currentRow.__is_new = false;
                            }
                            widget.view();
                        }, function(error) {
                            var errorMessage = 'Timeout';
                            if (error.data) {
                                errorMessage = error.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            var paramsNewCode = widget.paramsNewCode;
            
            var keysParamsNewCode = Object.keys(paramsNewCode);
            keysParamsNewCode.forEach(function(value) {
                currentRow[value] = paramsNewCode[value];
            });
    
            if (widget.isValid()) {
                widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                CRM_ParceiroNegocio_Service.salvarComunicacao(currentRow).then(function(successData) {
                    if (widget.isNewRow()) {
                        widget.currentRow.NRCOMUNICAPARC = successData.dataset.columnsToReturn.NRCOMUNICAPARC;
                        widget.currentRow.NRORG = successData.dataset.columnsToReturn.NRORG;
                        widget.currentRow.__is_new = false;
                    }
                    widget.view();
                }, function(error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
        
    };

    this.salvarEndereco = function(args) {
        var currentRow = args.row;
        var widget = args.owner.widget;
        var paramsNewCode = widget.paramsNewCode;
        var keysParamsNewCode = Object.keys(paramsNewCode);
        
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    keysParamsNewCode.forEach(function(value) {
                        currentRow[value] = paramsNewCode[value];
                    });
            
                    if (!widget.isNewRow()) {
                        currentRow.tipoEnderecoWasEdited = (widget.backupRow.CDTIPOENDERECO != currentRow.CDTIPOENDERECO);
                        currentRow.CDTIPOENDERECOANTIGO = widget.backupRow.CDTIPOENDERECO;
                    }
            
                    if (widget.isValid()) {
                        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                        widget.currentRow.TIPODEPARCEIRO = widget.parent.parent.currentRow.TIPODEPARCEIRO;
                        CRM_ParceiroNegocio_Service.salvarEndereco(currentRow).then(function(successData) {
                            if (widget.isNewRow()) {
                                widget.currentRow.NRENDERECOPARC = successData.dataset.columnsToReturn.NRENDERECOPARC;
                                widget.currentRow.__is_new = false;
                            }
                            widget.view();
                        }, function(error) {
                            var errorMessage = 'Timeout';
                            if (error.data) {
                                errorMessage = error.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            keysParamsNewCode.forEach(function(value) {
                currentRow[value] = paramsNewCode[value];
            });
    
            if (!widget.isNewRow()) {
                currentRow.tipoEnderecoWasEdited = (widget.backupRow.CDTIPOENDERECO != currentRow.CDTIPOENDERECO);
                currentRow.CDTIPOENDERECOANTIGO = widget.backupRow.CDTIPOENDERECO;
            }
    
            if (widget.isValid()) {
                widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
                widget.currentRow.TIPODEPARCEIRO = widget.parent.parent.currentRow.TIPODEPARCEIRO;
                CRM_ParceiroNegocio_Service.salvarEndereco(currentRow).then(function(successData) {
                    if (widget.isNewRow()) {
                        widget.currentRow.NRENDERECOPARC = successData.dataset.columnsToReturn.NRENDERECOPARC;
                        widget.currentRow.__is_new = false;
                    }
                    widget.view();
                }, function(error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
        
    };

    this.salvarNovoParceiro = function() {
        var parceiroWidget = templateManager.container.getWidget("parceiroNegocio");
        
        var nrParcNegocio = parceiroWidget.currentRow.NRPARCNEGOCIO;
        var tipoParc = parceiroWidget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    if (validateNewParceiro(parceiroWidget)) {
                        this.salvarParceiro(parceiroWidget);
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            if (validateNewParceiro(parceiroWidget)) {
                this.salvarParceiro(parceiroWidget);
            }
        }
        
    };

    this.salvarParceiro = function(widget, alreadyValidated) {
        var currentRow = widget.currentRow;
        var paramsNewCode = widget.paramsNewCode;
        var keysParamsNewCode = Object.keys(paramsNewCode);
        
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    keysParamsNewCode.forEach(function(value) {
                        currentRow[value] = paramsNewCode[value];
                    });
            
                    if (!widget.isNewRow()) {
                        currentRow.inscricaoWasEdited = (widget.backupRow.NRINSCRICAOPARC != currentRow.NRINSCRICAOPARC);
                    }
            
                    if (alreadyValidated || (validateNewParceiro(widget)) && widget.isValid()) {
                        this.nrinscricaoOnChange(widget.getField('NRINSCRICAOPARC'));
                        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                        CRM_ParceiroNegocio_Service.setTipoPrincipal(currentRow);
                        CRM_ParceiroNegocio_Service.salvarParceiro(currentRow).then(function(successData) {
                            toggleWidgetsEnabled(widget.widgets, true);
                            if (widget.isNewRow()) {
                                widget.currentWidget = widget;
            
                                var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
                                enderecoPrincipalWidget.isVisible = false;
                                enderecoPrincipalWidget.showAsTab = false;
            
                                var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
                                enderecoWidget.isVisible = true;
                                enderecoWidget.showAsTab = true;
                                widget.currentRow.NRPARCNEGOCIO = successData.dataset.columnsToReturn.NRPARCNEGOCIO;
                                widget.currentRow.__is_new = false;
            
                                widget.activate();
                            }
                            
                            widget.reload();
                            widget.view();
                            //BEGIN RD Station
                            if(widget.currentRow.CDTIPOPARCPRINCIPAL === 'CLIENTE') {
                                var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                                contactWidgets.dataSourceFilter.forEach(function(filter){
                                    if(filter.name === 'NRPARCNEGOCIO')   
                                        filter.value = widget.currentRow.NRPARCNEGOCIO;
                                });
                                contactWidgets.reload().then(function(){
                                    if(!Util.isEmptyOrBlank(contactWidgets.dataSource.data)){
                                        contactWidgets.dataSource.data.forEach(function(contact){
                                            restEngine.post('/IntegracaoRDStation/feedBackConversion', {'requestType':'Row', 'row': {EVENT_NAME:'Cadastro convertido em cliente no CRM', EMAIL:contact['EMAILINTERLOC']}}).
                                            then(function(){
                                                restEngine.post('/IntegracaoRDStation/changeFunnel', {'requestType':'Row', 'row': {FUNNEL: 'Client', EMAIL:contact['EMAILINTERLOC']}});
                                            });
                                        });
                                    }
                                });
                            }
                            //END RD Station
                            
                        }.bind(this), function(error) {
                            var errorMessage = 'Timeout';
                            if (error.data) {
                                errorMessage = error.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            keysParamsNewCode.forEach(function(value) {
                currentRow[value] = paramsNewCode[value];
            });
    
            if (!widget.isNewRow()) {
                currentRow.inscricaoWasEdited = (widget.backupRow.NRINSCRICAOPARC != currentRow.NRINSCRICAOPARC);
            }
    
            if (alreadyValidated || (validateNewParceiro(widget)) && widget.isValid()) {
                this.nrinscricaoOnChange(widget.getField('NRINSCRICAOPARC'));
                currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                CRM_ParceiroNegocio_Service.setTipoPrincipal(currentRow);
                CRM_ParceiroNegocio_Service.salvarParceiro(currentRow).then(function(successData) {
                    toggleWidgetsEnabled(widget.widgets, true);
                    if (widget.isNewRow()) {
                        widget.currentWidget = widget;
    
                        var enderecoPrincipalWidget = templateManager.container.getWidget("enderecoPrincipal");
                        enderecoPrincipalWidget.isVisible = false;
                        enderecoPrincipalWidget.showAsTab = false;
    
                        var enderecoWidget = templateManager.container.getWidget("parceiroNegocioEndereco");
                        enderecoWidget.isVisible = true;
                        enderecoWidget.showAsTab = true;
                        widget.currentRow.NRPARCNEGOCIO = successData.dataset.columnsToReturn.NRPARCNEGOCIO;
                        widget.currentRow.__is_new = false;
    
                        widget.activate();
                    }
                    
                    widget.reload();
                    widget.view();
                    //BEGIN RD Station
                    if(widget.currentRow.CDTIPOPARCPRINCIPAL === 'CLIENTE') {
                        var contactWidgets = templateManager.container.getWidget('WDGT_INTERLOCUTOR');
                        contactWidgets.dataSourceFilter.forEach(function(filter){
                            if(filter.name === 'NRPARCNEGOCIO')   
                                filter.value = widget.currentRow.NRPARCNEGOCIO;
                        });
                        contactWidgets.reload().then(function(){
                            if(!Util.isEmptyOrBlank(contactWidgets.dataSource.data)){
                                contactWidgets.dataSource.data.forEach(function(contact){
                                    restEngine.post('/IntegracaoRDStation/feedBackConversion', {'requestType':'Row', 'row': {EVENT_NAME:'Cadastro convertido em cliente no CRM', EMAIL:contact['EMAILINTERLOC']}}).
                                    then(function(){
                                        restEngine.post('/IntegracaoRDStation/changeFunnel', {'requestType':'Row', 'row': {FUNNEL: 'Client', EMAIL:contact['EMAILINTERLOC']}});
                                    });
                                });
                            }
                        });
                    }
                    //END RD Station
                    
                }.bind(this), function(error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
        
    };

    this.setTipoPrincipal = function(field) {
        var currentRow = field.widget.currentRow;
        CRM_ParceiroNegocio_Service.setTipoPrincipal(currentRow);
    };

    var toggleWidgetsEnabled = function(widgets, enabled) {
        widgets.forEach(function(widget) {
            widget.enabled = enabled;
        });
    };

    this.validarCepEnd = function(widget) {
        var CEP = widget.currentRow.NRCEPENDERECO || widget.currentRow.NRCEPENDERECO;
        var currentRow = widget.currentRow;
        if (CEP) {
            CRM_Utilities.buscarCep(CEP).then(function(response) {
                    
                var addressFound = response.dataset.ENDERECO;
                
                if(addressFound) {
                    
                    currentRow.NMPAIS = addressFound.NMPAIS ? addressFound.NMPAIS : '';
                    currentRow.CDPAIS = addressFound.CDPAIS ? addressFound.CDPAIS : '';
                    currentRow.NMESTADO = addressFound.NMESTADO ? addressFound.NMESTADO : '';
                    currentRow.SGESTADO = addressFound.SGESTADO ? addressFound.SGESTADO : '';
                    currentRow.NMMUNICIPIO = addressFound.NMMUNICIPIO ? addressFound.NMMUNICIPIO : '';
                    currentRow.CDMUNICIPIO = addressFound.CDMUNICIPIO ? addressFound.CDMUNICIPIO : '';
                    currentRow.NMBAIRRO = addressFound.NMBAIRRO ? addressFound.NMBAIRRO : '';
                    currentRow.CDBAIRRO = addressFound.CDBAIRRO ? addressFound.CDBAIRRO : '';
                    currentRow.DSENDERECO    = addressFound.DSENDERECO ? addressFound.DSENDERECO : '';
                    
                    this.alteraEstadoReadonly(widget);
                    
                    /*TODO Encontrar um jeito melhor de fazer o autocomplete atualizar os fields para os dados da currentRow*/
                    angular.element('#footer').click();
                    
                }else{
                    currentRow.CEP = '';
                }
                
                if(response.dataset.ERRO){
                    ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
                }
                
                if(response.messages){
                    ScreenService.showMessage(response.messages[0].message);    
                }
                
            }.bind(this)).catch(function(error){
                    ScreenService.showMessage('Erro ao realizar a busca.');
            });
        }
    };

    var validateNewParceiro = function(parceiroWidget) {
        if (parceiroWidget.isNewRow()) {
            var enderecoWidget = templateManager.container.getWidget("enderecoPrincipal");
            if (parceiroWidget.isValid() && enderecoWidget.isValid() && enderecoWidget.currentRow.CDPAIS) {
                parceiroWidget.currentRow.ENDERECO = Util.clone(enderecoWidget.currentRow);
                parceiroWidget.currentRow.ENDERECO.TIPODEPARCEIRO = parceiroWidget.currentRow.TIPODEPARCEIRO;
                return true;
            }
            else {
                if (!parceiroWidget.isValid() && (!enderecoWidget.isValid() || !enderecoWidget.currentRow.CDPAIS)) {
                    if(enderecoWidget.isValid() && !enderecoWidget.currentRow.CDPAIS) {
                        enderecoWidget.activate();

                        enderecoWidget.isValid();

                        parceiroWidget.currentWidget = parceiroWidget;
                        parceiroWidget.activate();
                    } else {
                        enderecoWidget.isValid();
                    }
                    ScreenService.showMessage("Preencha todos os campos obrigatórios das duas telas!");
                } else {
                    if((!enderecoWidget.isValid() || !enderecoWidget.currentRow.CDPAIS) && !enderecoWidget.isActive()) {
                        enderecoWidget.activate();
                        enderecoWidget.isValid();
                    } else if(!parceiroWidget.isValid() && !parceiroWidget.isActive()) {
                        parceiroWidget.currentWidget = parceiroWidget;
                        parceiroWidget.activate();
                    }
                    ScreenService.showMessage("Preencha os campos obrigatórios!");
                }
                return false;
            }
        }
        else {
            return true;
        }
    };
    
    this.novoContato = function(widget){
        var parentRow = widget.parent.parent.currentRow;
        var currentRow = widget.currentRow;
        
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    currentRow.NRPARCNEGOCIO = nrParcNegocio;
                    currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                    currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
                    
                    General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
                        if(response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if(response.dataset && response.dataset.GROUPREL[0] == false) {
                            widget.edit();
                            widget.newRow();
                            widget.currentRow.NRPARCNEGOCIO   = parentRow.NRPARCNEGOCIO;
                            widget.currentRow.NOMEPARC        = parentRow.NMPRINCIPALPARC;
                            widget.currentRow.EMAIL           = "";
                            widget.currentRow.TELEFONE        = null;
                            widget.currentRow.NRCOMUNICAPARC  = "";
                            widget.currentRow.NRRELACIONAPARC = "";
                            widget.currentRow.NRPARCNEGRELAC  = "";
                            widget.currentRow.NREMAIL         = "";
                            widget.currentRow.NRTELEFONE      = "";
                        } else {
                            ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                        }
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            currentRow.NRPARCNEGOCIO = nrParcNegocio;
            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
            
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
                if(response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if(response.dataset && response.dataset.GROUPREL[0] == false) {
                    widget.edit();
                    widget.newRow();
                    widget.currentRow.NRPARCNEGOCIO   = parentRow.NRPARCNEGOCIO;
                    widget.currentRow.NOMEPARC        = parentRow.NMPRINCIPALPARC;
                    widget.currentRow.EMAIL           = "";
                    widget.currentRow.TELEFONE        = null;
                    widget.currentRow.NRCOMUNICAPARC  = "";
                    widget.currentRow.NRRELACIONAPARC = "";
                    widget.currentRow.NRPARCNEGRELAC  = "";
                    widget.currentRow.NREMAIL         = "";
                    widget.currentRow.NRTELEFONE      = "";
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        }
        
        
    };
    
    this.salvarContato = function(args) {
        var currentRow = args.row;
        var widget = args.owner.widget;
        
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        
        currentRow.NRPARCNEGOCIO = nrParcNegocio;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    
                    General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
                        if(response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if(response.dataset && response.dataset.GROUPREL[0] == false) {
                            var paramsNewCode = widget.paramsNewCode;
                            if(!Util.isEmptyOrBlank(widget.currentRow['TELEFONE']))
                                widget.currentRow['TELEFONE'] = widget.currentRow['TELEFONE'].replace(/[^0-9]/g, '');
                            var email = currentRow.EMAIL;
                            var telefone = currentRow.TELEFONE;
                            widget.currentRow.PARENTTYPE    = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
                            if(Util.isEmptyOrBlank(widget.currentRow.NOMEPARC)){
                                widget.currentRow.NOMEPARC    = widget.parent.parent.currentRow.NMCANDIDATO;
                            }
                            
                            var keysParamsNewCode = Object.keys(paramsNewCode);
                            keysParamsNewCode.forEach(function(value) {
                                currentRow[value] = paramsNewCode[value];
                            });
                    
                            if (widget.isValid()) {
                                if(Util.isEmptyOrBlank(email) && Util.isEmptyOrBlank(telefone)){
                                    ScreenService.showMessage('Preencha pelo menos uma forma de comunicação (Email ou Telefone)');    
                                }else{
                                    CRM_ParceiroNegocio_Service.salvarContato(currentRow).then(function(successData) {
                                        widget.reload().then(function(){
                                            widget.view();
                                            var dataset = widget.dataSource.data;
                                            widget.currentRow.EMAIL = email;
                                            widget.currentRow.TELEFONE = telefone;
                                            widget.getField("TIPODEPARCEIRO").readOnly = false;
                                            widget.getField("NMTIPORELACIONA").readOnly = false;
                                            if(widget.currentRow.__is_new) ScreenService.closeSwipe();
                                            if(successData.dataset.columnsToReturn){
                                                widget.currentRow.NRPARCNEGRELAC = parseInt(successData.dataset.columnsToReturn.NRPARCNEGOCIO);
                                                widget.currentRow.NRRELACIONAPARC = parseInt(successData.dataset.columnsToReturn.NRRELACIONAPARC);
                                                this.setCurrentRow(dataset, currentRow);
                                                //widget.currentRow.NREMAIL = widget.dataSource.data[length-1].NREMAIL;
                                                //widget.currentRow.NRTELEFONE = widget.dataSource.data[length-1].NRTELEFONE;
                                            }
                                        }.bind(this));
                                    }.bind(this));
                                }
                            }
                        } else {
                            ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                        }
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
                if(response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if(response.dataset && response.dataset.GROUPREL[0] == false) {
                    var paramsNewCode = widget.paramsNewCode;
                    if(!Util.isEmptyOrBlank(widget.currentRow['TELEFONE']))
                        widget.currentRow['TELEFONE'] = widget.currentRow['TELEFONE'].replace(/[^0-9]/g, '');
                    var email = currentRow.EMAIL;
                    var telefone = currentRow.TELEFONE;
                    widget.currentRow.PARENTTYPE    = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
                    if(Util.isEmptyOrBlank(widget.currentRow.NOMEPARC)){
                        widget.currentRow.NOMEPARC    = widget.parent.parent.currentRow.NMCANDIDATO;
                    }
                    
                    var keysParamsNewCode = Object.keys(paramsNewCode);
                    keysParamsNewCode.forEach(function(value) {
                        currentRow[value] = paramsNewCode[value];
                    });
            
                    if (widget.isValid()) {
                        if(Util.isEmptyOrBlank(email) && Util.isEmptyOrBlank(telefone)){
                            ScreenService.showMessage('Preencha pelo menos uma forma de comunicação (Email ou Telefone)');    
                        }else{
                            CRM_ParceiroNegocio_Service.salvarContato(currentRow).then(function(successData) {
                                widget.reload().then(function(){
                                    widget.view();
                                    var dataset = widget.dataSource.data;
                                    widget.currentRow.EMAIL = email;
                                    widget.currentRow.TELEFONE = telefone;
                                    widget.getField("TIPODEPARCEIRO").readOnly = false;
                                    widget.getField("NMTIPORELACIONA").readOnly = false;
                                    if(widget.currentRow.__is_new) ScreenService.closeSwipe();
                                    if(successData.dataset.columnsToReturn){
                                        widget.currentRow.NRPARCNEGRELAC = parseInt(successData.dataset.columnsToReturn.NRPARCNEGOCIO);
                                        widget.currentRow.NRRELACIONAPARC = parseInt(successData.dataset.columnsToReturn.NRRELACIONAPARC);
                                        this.setCurrentRow(dataset, currentRow);
                                        //widget.currentRow.NREMAIL = widget.dataSource.data[length-1].NREMAIL;
                                        //widget.currentRow.NRTELEFONE = widget.dataSource.data[length-1].NRTELEFONE;
                                    }
                                }.bind(this));
                            }.bind(this));
                        }
                    }
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        }
    };
    
    this.edit = function(widget){
        var currentRow = widget.currentRow;
        
        widget.getField("TIPODEPARCEIRO").readOnly = true;
        widget.getField("NMTIPORELACIONA").readOnly = true;
        
        currentRow.NRPARCNEGOCIO = nrParcNegocio;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
            }
            if(response.dataset && response.dataset.GROUPREL[0] == false) {
                General.edit(widget);
            } else {
                ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
            }
        }.bind(this));
    };
    
    this.deleteCrud = function(widget){
        widget.currentRow.PARENTTYPE    = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        var currentRow = widget.currentRow;
        
        currentRow.NRPARCNEGOCIO = nrParcNegocio;
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
                    
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
                        if(response.dataset && response.dataset.error) {
                            ScreenService.showMessage(response.dataset.error, 'ERROR');
                        }
                        if(response.dataset && response.dataset.GROUPREL[0] == false) {
                            General.deleteCrud(widget);
                        } else {
                            ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                        }
                    }.bind(this));
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response){
                if(response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if(response.dataset && response.dataset.GROUPREL[0] == false) {
                    General.deleteCrud(widget);
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        }
    };
    
    this.backOrCancel = function(args){
        args.owner.widget.getField("NMTIPORELACIONA").readOnly = false;
        General.backOrCancel(args);
    };
    
    this.setCurrentRow = function(dataset, currentRow){
        dataset.forEach(function(row){
           var keys = Object.keys(row);
           keys.forEach(function(value){
              if(value === 'NRPARCNEGRELAC'){
                  if(row[value] === currentRow.NRPARCNEGRELAC){
                      currentRow.NREMAIL = row.NREMAIL;
                      currentRow.NRTELEFONE  = row.NRTELEFONE;
                  }
              } 
           });
        });
    };
    
    /**
     * Defini a visibilidade do campo de descrição 
     * na widget de contatos pelo tipo de parceiro
     * selecionado.
     * 
     * @param {object} field field de descrição.
    */
    this.setDescriptionFieldVisibilityByPartnerType = function(field){
        
        var widget = field.widget;
        var currentRow = widget.currentRow;
        var fieldValue = currentRow[field.name];
        
        var descriptionField = widget.getField('DSCARACINPROS');    
        
        if(fieldValue === "INTERLOCUTOR" && widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL === "PROSPECT"){
            descriptionField.isVisible = true;
        } else {
            descriptionField.isVisible = false;
        }
        
    };
    
    /**
     * Esconde o campo de descrição da widget de contatos
     * ('parceiroNegocioComunicacao').
     * 
     * @param {object} widget widget de contatos do parceiro
     * em caso.
    */
    this.hideDescriptionField = function(widget) {
        
        var descriptionField = widget.getField('DSCARACINPROS'); 
        descriptionField.isVisible = false;
        
    };
    
    /**
     * Define as regras da tela de parceiro de negócio 
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de parceiro
     * de negócio ('parceiroNegocio').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {
            
            var restrictObjectsByResale = [];
            
            restrictObjectsByResale.push(widget);
            restrictObjectsByResale.push(widget.getField('NMOPERRESPONSAVEL'));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjectsByResale);
            
        }
        
    };
    
    this.changeAgenciaReadOnly = function(widget){
        var fieldAgencia = widget.getField('NMAGENCIA');
        var fieldBanco   = widget.getField('NMBANCO');
        
        fieldAgencia.clearValue();
        if(Util.isEmptyOrBlank(fieldBanco.value())){
            fieldAgencia.readOnly = true; 
        }else{
            fieldAgencia.readOnly = false;
        }
        this.changeContaReadOnly(widget);
    };
    
    this.changeContaReadOnly = function(widget){
        var fieldAgencia = widget.getField('NMAGENCIA');
        var fieldConta   = widget.getField('DSCONTCORR');
        
        fieldConta.clearValue();
        if(Util.isEmptyOrBlank(fieldAgencia.value())){
           fieldConta.readOnly = true; 
        }else{
            fieldConta.readOnly = false;
        }
    };
        
    /**
     * Cria a widget de interlocutor na tela de parceiro
     * de negócio se o produto em execução for o CRM.
     * 
     * @param {object} widget widget de parceiro de negócio.
    */
    this.setInterlocutorWidgetOnParcNegocioWidget = function(widget){
        
        if(Boolean(templateManager.CRM_PARAMETRIZACAO)){
            AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(widget,5);
        }    
        
    };
    
    this.onEnterFormDadosAdicionais = function(widget){
        //Evita bug de ID no reload
        widget.mode = (widget.mode === "view" ? "list" : widget.mode);
        widget.reload().then(function(){
            var data = widget.dataSource.data;    
            if(Util.isEmptyOrBlank(data)){
                widget.currentRow = {};
                widget.currentRow.__is_new = true;
            }else{
                widget.currentRow = data[0];
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRPARCNEGOCIO = templateManager.container.getWidget('parceiroNegocio').currentRow.NRPARCNEGOCIO;
            widget.currentRow.NRORG = templateManager.container.getWidget('parceiroNegocio').currentRow.NRORG;
        });
    };
    
    this.saveDadosAdicionais = function(widget) {
        var widgPrinc = widget.parent.parent;
        var nrParcNegocio = widgPrinc.currentRow.NRPARCNEGOCIO;
        var tipoParc = widgPrinc.currentRow.CDTIPOPARCPRINCIPAL;

        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    if(widget.isValid()) {
                       General.saveCrud(widget);
                       widgPrinc.widgets.forEach((wid) => {
                           wid.enabled = true;
                       });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.saveCrud(widget);
            widgPrinc.widgets.forEach((wid) => {
               wid.enabled = true;
           });
        }
        
    };
    
    this.widgetOnEnterOnce = function(widget) {
        var filterRow = {};
        var fieldsToApply = ['IDATIVO'];
        filterRow.CDOPERRESPONSAVEL = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
        
        this.setResaleRules(widget);
        this.setInterlocutorWidgetOnParcNegocioWidget(widget);
        ABALogotipoParceiroController.setLogoWidgetOnActiveWidget(widget, 5);
    };
    
    this.verificaIsencao = function(widget) {
        var containerName = templateManager.container.name;
        var inscField;
        
        if(Util.isEmptyOrBlank(widget)) {
            widget = templateManager.container.getActiveWidget();
        }
        
        if(containerName === 'ger45000_prospect') {
            inscField = widget.getField('NRINSESTPROS');
        } else if(containerName === 'crm_cliente') {
            inscField = widget.getField('NRINSESTCLIE');
        } else {
            inscField = widget.getField('NRINSCESTADUAL');
        }
        
        if(widget.currentRow.IDINSCRESTAD === "ISENTO"){
            inscField.value("ISENTO");
            inscField.readOnly = true;
            if(containerName == 'crm_parceiro_negocio' && widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO') {
                inscField.validations = {};
            }
        }else if(containerName == 'crm_parceiro_negocio' && widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO' && Util.isEmptyOrBlank(widget.currentRow.IDINSCRESTAD)) {
            inscField.validations = {};
            inscField.value("");
            inscField.readOnly = false;
        } else {
            if(containerName == 'crm_parceiro_negocio' && widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO') {
                inscField.validations = { required: true };
            }
            inscField.value("");
            inscField.readOnly = false;
        }
        
    };
    
    this.setInscEstadualSelect = function(widget) {
        var containerName = templateManager.container.name;
        var selectInsc = widget.getField('IDINSCRESTAD');
        var inscField;
        
        if(Util.isEmptyOrBlank(widget)) {
            widget = templateManager.container.getActiveWidget();
        }

        if(containerName === 'ger45000_prospect') {
            inscField = widget.getField('NRINSESTPROS');
        } else if(containerName === 'crm_cliente') {
            inscField = widget.getField('NRINSESTCLIE');
        } else {
            inscField = widget.getField('NRINSCESTADUAL');
            if(containerName == 'crm_parceiro_negocio') {
                if(widget.getField('CDTIPOPARCPRINCIPAL').value() == 'CANDIDATO') {
                    selectInsc.hideEmptyValue = false;
                    inscField.validations = {};
                    selectInsc.validations = {};
                } else {
                    selectInsc.hideEmptyValue = true;
                    inscField.validations = {required: true};
                    selectInsc.validations = {required: true};
                }
            }
        }
        
        if(inscField.value() === 'ISENTO') {
            widget.currentRow.IDINSCRESTAD = 'ISENTO';
            inscField.readOnly = true;
        } else if(!Util.isEmptyOrBlank(inscField.value())){
            widget.currentRow.IDINSCRESTAD = 'NAOISENTO';
            inscField.readOnly = false;
        } else {
            inscField.readOnly = false;
            inscField.value("");            
        }
        
        
        
    };
    
    this.mergeParceiro = function(widget){
        var mainWid = widget.parent.parent;
        var currentRow = widget.currentRow;
        var sourcePartners = currentRow.NOME;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRORG = mainWid.currentRow.NRORG;
        currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCNEGOCIO = mainWid.currentRow.NRPARCNEGOCIO;

        if(currentRow.NRPARCNEGOCIO){

            var parcSeparatedByUnderline = "_";

            sourcePartners.forEach(function(value){
                parcSeparatedByUnderline = parcSeparatedByUnderline + value + "_";
            });
            currentRow.PARCTOSTRING = parcSeparatedByUnderline;
            
            var parametroRestEngine = {
                'requestType':'Row',
                'row': currentRow
            };

            restEngine.post('/mergeParceiro', parametroRestEngine,
             undefined, undefined, undefined).then(function(response){
                mainWid.reload();
                ScreenService.showMessage("Processo realizado com sucesso!");
                currentRow.NOME = "";
                ScreenService.closeSwipe();
                this.reloadParnersScreens(widget);
            }.bind(this));
        }else{

            ScreenService.showMessage(`Houve um problema ao tentar fundir os
                parceiros. Recarregue a página e tente novamente.`);
            currentRow.NOME = "";
        }
    };
    
    this.reloadParnersScreens = function(widget) {
        // Telas afetadas pela fusão dos parceiros
        var screensToReload = [
            'crm00040_000_leads',
            'ger45000_prospect',
            'crm00002_001_oportunidade_de_negocio',
        ];
        
        // Limpa a cache das telas, forçando seu recarregamento
        screensToReload.forEach(function(screenName) {
            delete templateManager.containers[screenName];
        });
    };
    
    this.openSwipeFundirAndSetName = function(){
        
        var widget = templateManager.container.getWidget('FUNDIRPARC');
        
        ScreenService.openSwipe(widget);
        ScreenService.closePopup();
        
        widget.activate();
        widget.newRow();
        
        widget.currentRow.NMPARCEIRO = widget.parent.parent.currentRow.NMPRINCIPALPARC;
        
    };
    
    this.closeWidgetFundirParc = function(){
        var widget = templateManager.container.getActiveWidget();
        
        ScreenService.closeSwipe().then(function(){
            this.cleanWidgetFields(widget);
            widget.parent.parent.view();
            widget.parent.parent.activate();
        }.bind(this));
    };
    
    this.cleanWidgetFields = function(widget){
        widget.fields.forEach(function(field){
            field.value("");
        });
    };
    
    this.checkParcHasMerge = function(nrparcneg, nrorg) {
        var params = {
            requestType: "Row",
            row: {
                NRPARCNEGOCIO: nrparcneg,
                NRORG: nrorg
            }
        };
        
        // Confere se o parceiro é o destino de alguma fusão
         return restEngine.post('/checkParcHasMerge', params,
         undefined, undefined, undefined).then(function(response){
            var hasMerge = response.dataset.DADOS.HASMERGE;
            
            return hasMerge;
        }.bind(this));
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
        
        var params = {
            requestType: 'Row',
            row: restRow
        };
        
        return restEngine.post('/checkIfCanEditOrEvolParc', params).then(response => {
            return response.dataset.DADOS.CAN_EDIT;
        }).catch(() => {
            return false;
        });
    };
    
    this.setTipoDeParceiroField = function(widget) {
        var rows = widget.dataSource.data;
        
        rows.forEach(function(row) {
            if(!Util.isEmptyOrBlank(row.TIPODEPARCEIRO)) {
                var tiposDeParceiro = row.TIPODEPARCEIRO.split(',');
            
                row.TIPODEPARCEIRO = tiposDeParceiro;
            }
        });
    };
    
    this.updatePartnership = function() {
        var widget = templateManager.container.getActiveWidget();
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        
        var tipoParceiro = widget.getField('TIPODEPARCEIRO');
        var tipoPrincParceiro = widget.getField('CDTIPOPARCPRINCIPAL');
        var valorCampo = tipoParceiro.value();
        var cont = 0;
        var extras = [];

        if(tipoPrincParceiro == 'PROSPECT' || tipoPrincParceiro == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    if(tipoPrincParceiro.value() == 'CLIENTE') {
                        valorCampo.forEach(function(tipoDoParceiro) {
                            if(tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                                cont++;
                            }else {
                                extras.push(tipoDoParceiro);
                            }
                        });
                        if(cont !== 3) {
                            tipoParceiro.value(['CANDIDATO', 'PROSPECT', 'CLIENTE']);
                            extras.forEach(function(ext) {
                                tipoParceiro.value().push(ext);
                            });
                            widget.backupRow = widget.currentRow;
                            this.salvarParceiro(widget, true);
                        }else {
                            ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                            return;
                        }
                    }else if(tipoPrincParceiro.value() == 'PROSPECT') {
                        valorCampo.forEach(function(tipoDoParceiro) {
                            if(tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                                cont++;
                            }else {
                                extras.push(tipoDoParceiro);
                            }
                        });
                        if(cont !== 2) {
                            tipoParceiro.value(['CANDIDATO', 'PROSPECT']);
                            extras.forEach(function(ext) {
                                tipoParceiro.value().push(ext);
                            });
                            widget.backupRow = widget.currentRow;
                            this.salvarParceiro(widget, true);
                        }else {
                            ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                            return;
                        }
                    }else if(tipoPrincParceiro.value() == 'CANDIDATO') {
                        valorCampo.forEach(function(tipoDoParceiro) {
                            if(tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                                cont++;
                            }else {
                                extras.push(tipoDoParceiro);
                            }
                        });
                        if(cont !== 1) {
                            tipoParceiro.value(['CANDIDATO']);
                            extras.forEach(function(ext) {
                                tipoParceiro.value().push(ext);
                            });
                            widget.backupRow = widget.currentRow;
                            this.salvarParceiro(widget, true);
                        }else {
                            ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                            return;
                        }
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            if(tipoPrincParceiro.value() == 'CLIENTE') {
                valorCampo.forEach(function(tipoDoParceiro) {
                    if(tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                        cont++;
                    }else {
                        extras.push(tipoDoParceiro);
                    }
                });
                if(cont !== 3) {
                    tipoParceiro.value(['CANDIDATO', 'PROSPECT', 'CLIENTE']);
                    extras.forEach(function(ext) {
                        tipoParceiro.value().push(ext);
                    });
                    widget.backupRow = widget.currentRow;
                    this.salvarParceiro(widget, true);
                }else {
                    ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                    return;
                }
            }else if(tipoPrincParceiro.value() == 'PROSPECT') {
                valorCampo.forEach(function(tipoDoParceiro) {
                    if(tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                        cont++;
                    }else {
                        extras.push(tipoDoParceiro);
                    }
                });
                if(cont !== 2) {
                    tipoParceiro.value(['CANDIDATO', 'PROSPECT']);
                    extras.forEach(function(ext) {
                        tipoParceiro.value().push(ext);
                    });
                    widget.backupRow = widget.currentRow;
                    this.salvarParceiro(widget, true);
                }else {
                    ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                    return;
                }
            }else if(tipoPrincParceiro.value() == 'CANDIDATO') {
                valorCampo.forEach(function(tipoDoParceiro) {
                    if(tipoDoParceiro == 'CLIENTE' || tipoDoParceiro == 'PROSPECT' || tipoDoParceiro == 'CANDIDATO') {
                        cont++;
                    }else {
                        extras.push(tipoDoParceiro);
                    }
                });
                if(cont !== 1) {
                    tipoParceiro.value(['CANDIDATO']);
                    extras.forEach(function(ext) {
                        tipoParceiro.value().push(ext);
                    });
                    widget.backupRow = widget.currentRow;
                    this.salvarParceiro(widget, true);
                }else {
                    ScreenService.showMessage("Este parceiro já possui suas parcerias atualizadas!");
                    return;
                }
            }
        }
        
    };
    
    this.setStatusFilter = function() {
        var widget = templateManager.container.getActiveWidget();
        
        widget.dataSourceFilter.find(x => x.name == 'P_NRPARCNEGOCIO').value = widget.getParent().currentRow.NRPARCNEGOCIO;
        widget.reload();
    };
    
    this.goBackToGrid = function() {
        var mainWidget = templateManager.container.getWidget('parceiroNegocio');
        
        ScreenService.closeSwipe();
        mainWidget.activate();
    };
    
    this.showMessageCantEditParc = function() {
        var message = `Ação bloqueada!<br>
             Somente o operador responsável pelo prospect e seus assistentes podem
             editá-lo/evoluí-lo.`;
             
        ScreenService.showMessage(message);
    };
    
    this.dadosAdicionaisEdit = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.widgetEdit(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.widgetEdit(widget);
        }
        
    };
    
    this.deleteParc = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.deleteCrud(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.deleteCrud(widget);
        }
        
    };
    
    this.editComunication = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.edit(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.edit(widget);
        }
        
    }; 
    
    this.deleteComunication = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.deleteCrud(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.deleteCrud(widget);
        }
        
    };
    
    this.addNewAccount = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.widgetNewRow(widget);
                    this.changeAgenciaReadOnly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
            
        } else {
            General.widgetNewRow(widget);
            this.changeAgenciaReadOnly(widget);
        }
        
    };
    
    this.editAccount = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.widgetEdit(widget);
                    this.changeAgenciaReadOnly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
            
        } else {
            General.widgetEdit(widget);
            this.changeAgenciaReadOnly(widget);
        }
        
    };
    
    this.saveAccount = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.widgetEdit(widget);
                    this.changeAgenciaReadOnly(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.widgetEdit(widget);
            this.changeAgenciaReadOnly(widget);
        }
        
    };
    
    this.deleteAccount = function(widget) {
        var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.parent.parent.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.deleteCrud(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.deleteCrud(widget);
        }
        
    };
    
    this.cancelAccount = function(widget) {
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        var tipoParc = widget.currentRow.CDTIPOPARCPRINCIPAL;
        
        if(tipoParc == 'PROSPECT' || tipoParc == 'CLIENTE'){
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    General.widgetCancelForm(widget);
                } else {
                    this.showMessageCantEditParc();
                }
            });
        } else {
            General.widgetCancelForm(widget);
        }
    };
    
    this.openTransferirResponsaveis = function() {
        var widget = templateManager.container.getWidget('transferenciaDeOperadores');
        ScreenService.openPopup(widget);
        widget.newRow();
    };
    
    this.fecharTransferencia = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('parceiroNegocio').activate();
    };
    
    this.transferirResponsaveis = function() {
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()) {
            var mainWid = templateManager.container.getWidget('parceiroNegocio');
            var rows = mainWid.getCheckedRows();
            
            rows.forEach((row) => {
                row.NRORG = getLocalVar('CRM_NRORGTRAB');
                row.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                row.CDOPERADORDEST = widget.currentRow.CDOPERADORDEST;
            });
            
            var parametroRestEngine = {
                'requestType':'Row',
                'row': rows
            };
    
            restEngine.post('/transferirParceiros', parametroRestEngine).then(function(response){
                mainWid.reload();
                ScreenService.closePopup();
                ScreenService.showMessage("Transferência realizada com sucesso!");
                mainWid.activate();
            }.bind(this));
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('CRM_ParceiroNegocio_Controller', CRM_ParceiroNegocio_Controller);
});